clang 8.0.0

Public Member Functions | Protected Member Functions | List of all members
clang::serialized_diags::SerializedDiagnosticReader Class Reference

A base class that handles reading serialized diagnostics from a file. More...

`#include "clang/Frontend/SerializedDiagnosticReader.h"`

## Public Member Functions
| SerializedDiagnosticReader ()=default
virtual | ~SerializedDiagnosticReader ()=default
std::error_code | readDiagnostics (StringRef File)
| Read the diagnostics in `File`. More...

## Protected Member Functions
virtual std::error_code | visitStartOfDiagnostic ()
| Visit the start of a diagnostic block. More...
virtual std::error_code | visitEndOfDiagnostic ()
| Visit the end of a diagnostic block. More...
virtual std::error_code | visitCategoryRecord (unsigned ID, StringRef Name)
| Visit a category. This associates the category `ID` to a `Name`. More...
virtual std::error_code | visitDiagFlagRecord (unsigned ID, StringRef Name)
| Visit a flag. This associates the flag's `ID` to a `Name`. More...
virtual std::error_code | visitDiagnosticRecord (unsigned Severity, const Location &Location, unsigned Category, unsigned Flag, StringRef Message)
| Visit a diagnostic. More...
virtual std::error_code | visitFilenameRecord (unsigned ID, unsigned Size, unsigned Timestamp, StringRef Name)
| Visit a filename. This associates the file's `ID` to a `Name`. More...
virtual std::error_code | visitFixitRecord (const Location &Start, const Location &End, StringRef Text)
| Visit a fixit hint. More...
virtual std::error_code | visitSourceRangeRecord (const Location &Start, const Location &End)
| Visit a source range. More...
virtual std::error_code | visitVersionRecord (unsigned Version)
| Visit the version of the set of diagnostics. More...

## Detailed Description

A base class that handles reading serialized diagnostics from a file.

Subclasses should override the visit* methods with their logic for handling the various constructs that are found in serialized diagnostics.

Definition at line 61 of file SerializedDiagnosticReader.h.

## Constructor & Destructor Documentation

## ◆ SerializedDiagnosticReader()

clang::serialized_diags::SerializedDiagnosticReader::SerializedDiagnosticReader | ( |  | ) |
| default

## ◆ ~SerializedDiagnosticReader()

virtual clang::serialized_diags::SerializedDiagnosticReader::~SerializedDiagnosticReader | ( |  | ) |
| virtual default

## Member Function Documentation

## ◆ readDiagnostics()

std::error_code SerializedDiagnosticReader::readDiagnostics | ( | StringRef | File | ) |

Read the diagnostics in `File`.

Definition at line 29 of file SerializedDiagnosticReader.cpp.

References clang::serialized_diags::BLOCK_DIAG, clang::serialized_diags::BLOCK_META, clang::serialized_diags::CouldNotLoad, clang::FileManager::getBufferForFile(), clang::serialized_diags::InvalidDiagnostics, clang::serialized_diags::InvalidSignature, clang::serialized_diags::MalformedBlockInfoBlock, and clang::serialized_diags::MalformedTopLevelBlock.

## ◆ visitCategoryRecord()

virtual std::error_code clang::serialized_diags::SerializedDiagnosticReader::visitCategoryRecord | ( | unsigned | ID,
|  | StringRef | Name
| ) |  |
| inline protected virtual

Visit a category. This associates the category `ID` to a `Name`.

Definition at line 90 of file SerializedDiagnosticReader.h.

## ◆ visitDiagFlagRecord()

virtual std::error_code clang::serialized_diags::SerializedDiagnosticReader::visitDiagFlagRecord | ( | unsigned | ID,
|  | StringRef | Name
| ) |  |
| inline protected virtual

Visit a flag. This associates the flag's `ID` to a `Name`.

Definition at line 95 of file SerializedDiagnosticReader.h.

## ◆ visitDiagnosticRecord()

virtual std::error_code clang::serialized_diags::SerializedDiagnosticReader::visitDiagnosticRecord | ( | unsigned | Severity,
|  | const Location & | Location,
|  | unsigned | Category,
|  | unsigned | Flag,
|  | StringRef | Message
| ) |  |
| inline protected virtual

Visit a diagnostic.

Definition at line 101 of file SerializedDiagnosticReader.h.

## ◆ visitEndOfDiagnostic()

virtual std::error_code clang::serialized_diags::SerializedDiagnosticReader::visitEndOfDiagnostic | ( |  | ) |
| inline protected virtual

Visit the end of a diagnostic block.

Definition at line 87 of file SerializedDiagnosticReader.h.

## ◆ visitFilenameRecord()

virtual std::error_code clang::serialized_diags::SerializedDiagnosticReader::visitFilenameRecord | ( | unsigned | ID,
|  | unsigned | Size,
|  | unsigned | Timestamp,
|  | StringRef | Name
| ) |  |
| inline protected virtual

Visit a filename. This associates the file's `ID` to a `Name`.

Definition at line 107 of file SerializedDiagnosticReader.h.

## ◆ visitFixitRecord()

virtual std::error_code clang::serialized_diags::SerializedDiagnosticReader::visitFixitRecord | ( | const Location & | Start,
|  | const Location & | End,
|  | StringRef | Text
| ) |  |
| inline protected virtual

Visit a fixit hint.

Definition at line 115 of file SerializedDiagnosticReader.h.

## ◆ visitSourceRangeRecord()

virtual std::error_code clang::serialized_diags::SerializedDiagnosticReader::visitSourceRangeRecord | ( | const Location & | Start,
|  | const Location & | End
| ) |  |
| inline protected virtual

Visit a source range.

Definition at line 120 of file SerializedDiagnosticReader.h.

## ◆ visitStartOfDiagnostic()

virtual std::error_code clang::serialized_diags::SerializedDiagnosticReader::visitStartOfDiagnostic | ( |  | ) |
| inline protected virtual

Visit the start of a diagnostic block.

Definition at line 84 of file SerializedDiagnosticReader.h.

## ◆ visitVersionRecord()

virtual std::error_code clang::serialized_diags::SerializedDiagnosticReader::visitVersionRecord | ( | unsigned | Version | ) |
| inline protected virtual

Visit the version of the set of diagnostics.

Definition at line 126 of file SerializedDiagnosticReader.h.

The documentation for this class was generated from the following files:

- include/clang/Frontend/SerializedDiagnosticReader.h
- lib/Frontend/SerializedDiagnosticReader.cpp